/**
   Prints to standard output the last ten lines of a text file.
   Reads from standard input unless there is a command-line
   argument, which should be the name of a text file.
*/
import java.io.*;

public class Last
{
   public static void main(String[] args) throws IOException
   {
      int tail = 10;
      String[] lineQueue = new String[tail];

      BufferedReader br = new BufferedReader(
         (0 == args.length) ? new InputStreamReader(System.in)
                            : new FileReader(args[0]) );

      int lineCount = 0;
      for (String oneLine = null; (oneLine = br.readLine()) != null; lineCount++)
         lineQueue[lineCount % tail] = oneLine;

      if (lineCount < tail) tail = lineCount;

      for (int i = 0; i < tail; i++)
         System.out.println(lineQueue[(lineCount + i) % tail]);
   }
}