/**
   Prints to standard output a range of lines from a text file.

   Take command-line arguments of the form
       Range n m filename
   or
       Range n m
   and print lines n through m of the named file,
   or lines n through m from standard input.

   If there are fewer than n line of input, output nothing.
   If there are more than n but fewer than m lines of input,
   print all the lines from line n on.
*/
import java.io.*;

public class Range
{
   public static void main(String[] args) throws IOException
   {
      if (2 > args.length)
      {
         System.err.println("usage: Range minLineNumber maxLineNumber [filename]");
         System.exit(-1);
      }

      int start = Integer.parseInt( args[0] );
      int   end = Integer.parseInt( args[1] );

      BufferedReader br = new BufferedReader(
         (3 > args.length) ? new InputStreamReader(System.in)
                           : new FileReader(args[2]) );

      String line;
      for (int c = 1; (c <= end) && (line = br.readLine()) != null; c++)
         if (c >= start)
            System.out.println( line );
   }
}