/*
   This version is a more correct version of last (compared
   with last-v1.c). This version counts lines correctly (the
   line count does not depend on the value of LINELEN) but this
   version truncates each line so that it has length LINELEN.

   Try running this program with a small value for LINELEN.


   Prints to standard output the last ten lines of a text file.
   Reads from standard input unless there is a command-line
   argument, which should be the name of a text file.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define  LINELEN  512

int main(int argc, char* argv[])
{
   int i;
   FILE *fp = stdin;
   int tail = 10;
   int lineCount = 0;
   char lineQueue[tail][LINELEN];
   char garbageBuffer[LINELEN];  // for overly long lines

   if ( (1 < argc) && ((fp = fopen(argv[1], "r")) == NULL) )
   {
      char msg[BUFSIZ];
      sprintf(msg, "Problem with %s", argv[1]);
      perror(msg);
   }

   for ( ; fgets(lineQueue[lineCount % tail], LINELEN, fp); lineCount++)
      if ( strchr(lineQueue[lineCount % tail], '\n') == NULL )
      {  lineQueue[lineCount % tail][LINELEN - 2] = '\n';
         // read, and discard, the rest of the line
         fgets(garbageBuffer, LINELEN, fp);
         while ( (strchr(garbageBuffer, '\n') == NULL) && fgets(garbageBuffer, LINELEN, fp) );
      }

   if (tail > lineCount) tail = lineCount;

   for (i = 0; i < tail; i++)
      printf("%s", lineQueue[(lineCount + i) % tail]);

   fclose( fp );
   return 0;
}
