/*
   This is a correct version of last. This version
   counts lines correctly and it reads each line
   completely. The correctness of this version does
   not depend on the value of LINELEN.

   Try running this program with a small value for LINELEN.


   Prints to standard output the last ten lines of a text file.
   Reads from standard input unless there is a command-line
   argument, which should be the name of a text file.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define  LINELEN  512

int main(int argc, char* argv[])
{
   int i;
   FILE *fp = stdin;
   int tail = 10;
   int lineCount = 0;
   char *lineQueue[tail];
   char *rtn;

   if ( (1 < argc) && ((fp = fopen(argv[1], "r")) == NULL) )
   {
      char msg[BUFSIZ];
      sprintf(msg, "Problem with %s", argv[1]);
      perror(msg);
   }

   for (i = 0; i < tail; i++)
      lineQueue[i] = (char*)malloc(LINELEN);

   for ( ; fgets(lineQueue[lineCount % tail], LINELEN, fp); lineCount++)
      if ( strchr(lineQueue[lineCount % tail], '\n') == NULL )
      {
         size_t lineLength = LINELEN;
         lineQueue[lineCount % tail] = realloc( lineQueue[lineCount % tail], lineLength + LINELEN );
         rtn = fgets( &(lineQueue[lineCount % tail][lineLength - 1]), LINELEN + 1, fp );
         while ( rtn && (strchr(&(lineQueue[lineCount % tail][lineLength - 1]), '\n')  == NULL) )
         {
            lineLength = lineLength + LINELEN;
            lineQueue[lineCount % tail] = realloc( lineQueue[lineCount % tail], lineLength + LINELEN );
            rtn = fgets( &(lineQueue[lineCount % tail][lineLength - 1]), LINELEN + 1, fp);
         }
      }

   if (tail > lineCount) tail = lineCount;

   for (i = 0; i < tail; i++)
      printf("%s", lineQueue[(lineCount + i) % tail]);

   fclose( fp );
   return 0;
}
