/*
   This version is correct but it is not Standard C.
   This version uses the getline() funtion (which
   does most of the memory management for us).

   http://man7.org/linux/man-pages/man3/getline.3.html


   Prints to standard output the last ten lines of a text file.
   Reads from standard input unless there is a command-line
   argument, which should be the name of a text file.
*/
#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char* argv[])
{
   int i;
   FILE *fp = stdin;
   int tail = 10;
   int lineCount = 0;
   char *lineQueue[tail];
   char *oneLine = NULL;
   size_t n = 0;

   if ( (1 < argc) && ((fp = fopen(argv[1], "r")) == NULL) )
   {
      char msg[BUFSIZ];
      sprintf(msg, "Problem with %s", argv[1]);
      perror(msg);
   }

   for (i = 0; i < tail; i++)
      lineQueue[i] = NULL;

   oneLine = NULL; // have getline() do the allocation
   n = 0;
   for ( ; getline(&oneLine, &n, fp) != -1; lineCount++)
   {
      free( lineQueue[lineCount % tail] );
      lineQueue[lineCount % tail] = oneLine;
      oneLine = NULL; // have getline() do the allocation
      n = 0;
   }

   if (tail > lineCount) tail = lineCount;

   for (i = 0; i < tail; i++)
      printf("%s", lineQueue[(lineCount + i) % tail]);

   fclose( fp );
   return 0;
}
