/*
   Prints to standard output a range of lines from a text file.

   Take command-line arguments of the form
       range n m filename
   or
       range n m
   and print lines n through m of the named file,
   or lines n through m from standard input.

   If there are fewer than n line of input, output nothing.
   If there are more than n but fewer than m lines of input,
   print all the lines from line n on.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define  LINELEN  512

int main(int argc, char* argv[])
{
   int c;
   char line[LINELEN];
   FILE *fp = stdin;

   if (3 > argc)
   {
      fprintf(stderr, "usage: %s start_line_no stop_line_no [filename]\n", argv[0]);
      exit(EXIT_FAILURE);
   }

   int start = atoi(argv[1]);
   int   end = atoi(argv[2]);

   if ( (3 < argc) && ((fp = fopen(argv[3], "r")) == NULL) )
   {
      char msg[BUFSIZ];
      sprintf(msg, "Problem with %s", argv[3]);
      perror(msg);
   }

   for (c = 1; (c <= end) && fgets(line, LINELEN, fp); c++)
      do
         if (c >= start)
            printf("%s", line );
      while ( (strchr(line, '\n') == NULL) && fgets(line, LINELEN, fp) );

   fclose( fp );
   return 0;
}
